//-----------------------------------------------3DofDuino 0.01-----------------------------------------------------
//-------------------------------Daniel Christiansen - X-Sim->Arduino mega Interface -------------------------------
//--------------------------------------daniel.christiansen@gmail.com ----------------------------------------------


//--------------------------------------------------USAGE-----------------------------------------------------------

// ##protocol## 
// syntax:
// $<axis><value>#<checkvalue>*

// example:
// $X123#123*

// 1-axis example for x-sim2:
// ~36~X~a01~~35~~a01~~42~   // Axis in CAPITAL letters

// 3-axis example for x-sim2:
// ~36~X~a01~~35~~a01~~42~~36~Y~a02~~35~~a02~~42~~36~Z~a03~~35~~a03~~42~  // Axis in CAPITAL letters
  
// Use the USO output 16 bits - decimal - 115200 - 8 - NOPARITY - ONESTOPBIT

//--------------------------------------------------USAGE-----------------------------------------------------------


//--------------------------------------------Configuration---------------------------------------------------------

// ##Pin Assignment##
int rxOkLed     = 32;
int rxNotOkLed  = 33;
int ServoXPin   = 7;
int ServoYPin   = 8;
int ServoZPin   = 9;
// ##Pin Assignment##
int servosMinValue = 0; // servos motion range minimum value
int servosMaxValue = 180; // servos motion range maximum value
int servoval = 90; // servos initial start point

//--------------------------------------------Configuration---------------------------------------------------------


#include <Servo.h> 

Servo servoX;
Servo servoY;
Servo servoZ;
  
unsigned int charbuffer[50];
int bytesread = 0;
int serialchar;
int axis;
boolean packageRecieved = false;
boolean PackageVaild = false;
int packageLength;


  
  
void setup() {
  Serial.begin(115200);        // Connect to the serial port
 
  pinMode(rxOkLed,OUTPUT);     // Package verified led     
  pinMode(rxNotOkLed,OUTPUT);  // Package  Corrupt led
  
  servoX.attach(ServoXPin);            
  servoY.attach(ServoYPin);
  servoZ.attach(ServoZPin);
}

void loop () {
  unsigned int axisValue;
  unsigned int axisValueCheck;
 
  if(Serial.available() > 0) {
    serialchar = Serial.read();
       // Serial.print("\nbyte: ");
       // Serial.print(serialchar);
    
    if (serialchar == 42){
      packageRecieved = true;
      packageLength = bytesread;
      bytesread = 0;
    // Serial.print("\nPackage recieved!!");
    }
    
    else {
    
      if ((serialchar == 36) || (bytesread > 0) && (packageRecieved == false)) {
       charbuffer[bytesread] = serialchar;
       bytesread ++; // ready for next char
       //Serial.print("\nbytesread: ");
       //Serial.print(bytesread);
       //Serial.print("\nbyte: ");
       //Serial.print(serialchar);
       }
     } 
   }
 digitalWrite(rxOkLed,LOW);
 digitalWrite(rxNotOkLed,LOW);
 
  if (packageRecieved == true){
   int valueLength = (packageLength - 3) / 2;
   int decMultiplier = 1;
   axisValue = 0;
   axisValueCheck= 0;
   
   for (int i=valueLength; i > 0; i--){
    axisValue = axisValue + ((charbuffer[i + 1 ] - 48) * decMultiplier);
    axisValueCheck = axisValueCheck + ((charbuffer[i + valueLength + 2] - 48) * decMultiplier);
    decMultiplier = decMultiplier * 10;
    }
  
  if (axisValue == axisValueCheck){
    axis = charbuffer[1];
    PackageVaild = true;
    //Serial.print("\naxisValue: ");
    //Serial.print(axisValue);
    //Serial.print("\naxisValueCheck: ");
    //Serial.print(axisValueCheck);
    
    if (PackageVaild == true){
      digitalWrite(rxOkLed,HIGH); // blink the OK led
      servoval = map(axisValue, 0, 65535, servosMinValue, servosMaxValue); 
      
      switch (axis) {
        case 88: //ascii for X
             servoX.write(servoval); 
        break; 
        
        case 89: //ascii for Y
             servoY.write(servoval); 
        break;
        
        case 90://ascii for Z
             servoZ.write(servoval); 
       
       }
     }
   } 
    else {
      digitalWrite(rxNotOkLed,HIGH); //blink the Not OK led
      }
    
  packageRecieved = false; // were now done with this package - on to the next one
   
}

}
